; ---------------------------------------------------------------------
; SWITCHER - copies BASIC to RAM and a ROM pre-loaded at $4000
; then modifies BASIC so that re-starting, the system doesn't 
; initialize RAM to zero
; ---------------------------------------------------------------------
       org   $2800
       put   $2800
; ---------------------------------------------------------------------
       orcc  #$50								; disable interrupts
       ldx   #$8000							; point to BASIC beginning
Loop1  sta   $ffde							; switch to MAP0
       ldd   ,x								; read 2 bytes from ROM
       sta   $ffdf							; switch to MAP1
       std   ,x++								; put at same place in RAM space
       cmpx  #$c000							; got to the end?
       blo   Loop1							; no, keep on
       ldx   #$4000							; point to ROM game loaded in RAM
       ldu   #$c000							; point to destination
Loop2  ldd   ,x++								; read 2 bytes
       std   ,u++								; put at destination
       cmpx  #$6000							; got to the end?
       blo   Loop2							; no, keep on
       lda   #$0e								; bytes to modify
       sta   $bb72							; change BASIC
       ldx   #$b3ca							; point to RAM verification routine into ColdReset
       ldd   #$120c							; code NOP for 12 bytes
Loop3  sta   ,x+								; overwrite BASIC code
       decb										; decrement counter
       bne   Loop3							; not yet done? loop
       lda   #$8e								; opcode LDX
       sta   ,x+								; put into Basic
       ldd   #$7fff							; get end of RAM address
       std   ,x								; modify Basic
       clr   <$71								; cold start flag
       jmp   $b3b4							; do restart
; ---------------------------------------------------------------------
